<?php

/**
 * Plugin Name: No copy allowed, disable copy - Nork Tecnologia
 * Plugin URI: https://nork.com.br
 * Description: Plugin to block text copies, print screen, "print/save as" PDF and disable many copy keys
 * Author: Caio Peres
 * Author URI: https://cjperes.github.io
 * Version: 1.0.5
 */

if (!defined('ABSPATH')) {
    exit; // tela branca caso o plugin for acessado direto
}

// adicionar função ao footer do wordpress
add_action('wp_footer', 'ncjp_footer_scp');
function ncjp_footer_scp()
{
    ?>
    <script language="javascript">
        function NcjpclearData() {
            window.clipboardData.setData('text', '')
        }

        function cldata() {
            if (clipboardData) {
                clipboardData.NcjpclearData();
            }
        }
        setInterval("cldata();", 1000);


        document.addEventListener("keyup", function(e) {
            var keyCode = e.keyCode ? e.keyCode : e.which;
            if (keyCode == 44) {
                e.preventDefault();
                NcjpstopPrntScr();
            }
        });


        function NcjpstopPrntScr() {

            var inpFld = document.createElement("input");
            inpFld.setAttribute("value", ".");
            inpFld.setAttribute("width", "0");
            inpFld.style.height = "0px";
            inpFld.style.width = "0px";
            inpFld.style.border = "0px";
            document.body.appendChild(inpFld);
            inpFld.select();
            document.execCommand("copy");
            inpFld.remove(inpFld);
        }

        function NcjpAccessClipboardData() {
            try {
                window.clipboardData.setData('text', "Conteúdo protegido por direitos autorais.");
            } catch (err) {}
        }
        setInterval("NcjpAccessClipboardData()", 300);
    </script>

    <style type="text/css" media="print">
        body {
            visibility: hidden !important;
            display: none !important;
            -moz-appearance: none;
            -webkit-appearance: none;
        }
    </style>

    <script language="javascript">
        //desabilita ctrl + s; ctrl + u; ctrl+v; ctr+c; ctrl+p;
        document.onkeydown = function(e) {
            if (e.ctrlKey &&
                (e.keyCode === 67 ||
                    e.keyCode === 85 ||
                    e.keyCode === 80 ||
                    e.keyCode === 83 ||
                    e.keyCode === 117)) {
                return false;
            } else {
                return true;
            }
        };
    </script>


    <body ondragstart="return false;" onselectstart="return false;" oncontextmenu="return false;" onload="NcjpclearData(); " onblur="NcjpclearData(); ">
    <?php
} ?>

<?php /*
function ncjp_admin_notice__success()
{
    ?>
        <div class="notice notice-success is-dismissible">
            <p><?php _e('Success! Your site is protected against copying content and images, <a href="https://wordpress.org/support/plugin/no-copy-block-text-selection/reviews/#new-post" target="blank">If you like the plugin, consider rating the plugin with 5 stars ⭐⭐⭐⭐⭐, encourages us to add new features in the future!</a>'); ?></p>
        </div>
    <?php
}
add_action('admin_notices', 'ncjp_admin_notice__success');
*/
?>


    <?php

/**
 * Generated by the WordPress Option Page generator
 * at http://jeremyhixon.com/wp-tools/option-page/
 */

    class BlockCopy
    {
        private $block_copy_options;

        public function __construct()
        {
            add_action('admin_menu', array( $this, 'block_copy_add_plugin_page' ));
            add_action('admin_init', array( $this, 'block_copy_page_init' ));
        }

        public function block_copy_add_plugin_page()
        {
            add_options_page(
                'Block copy', // page_title
                'Block copy', // menu_title
                'manage_options', // capability
                'block-copy', // menu_slug
                array( $this, 'block_copy_create_admin_page' ) // function
            );
        }

        public function block_copy_create_admin_page()
        {
            $this->block_copy_options = get_option('block_copy_option_name'); ?>

<div class="wrap">
                <h1>Your site is protected!</h1>
                <ul>
                    <li>✔ Disable copy of text</li>
                    <li>✔ Disable right mouse click</li>
                    <li>✔ Disable print screen</li>
                    <li>✔ Disable print to PDF</li>
                    <li>✔ Disable Ctrl+U (view source)</li>
                    <li>✔ Disable Ctrl+P (Print)</li>
                    <li>✔ Disable Print with printer</li>
                    <li>✔ Disable Ctrl+S (Save page)</li>
                    <li>✔ Disable Ctrl+C</li>
                </ul>
                <p><a href="https://wordpress.org/support/plugin/no-copy-block-text-selection/reviews/#new-post" target="blank">If you like the plugin, consider rating the plugin with 5 stars ⭐⭐⭐⭐⭐, encourages us to add new features in the future!</a></p>
            </div>
        <?php }

        public function block_copy_page_init()
        {
            register_setting(
                'block_copy_option_group', // option_group
                'block_copy_option_name', // option_name
                array( $this, 'block_copy_sanitize' ) // sanitize_callback
            );

            add_settings_section(
                'block_copy_setting_section', // id
                'Settings', // title
                array( $this, 'block_copy_section_info' ), // callback
                'block-copy-admin' // page
            );

            add_settings_field(
                'your_site_is_protected_0', // id
                'Your site is protected!', // title
                array( $this, 'your_site_is_protected_0_callback' ), // callback
                'block-copy-admin', // page
                'block_copy_setting_section' // section
            );
        }

        public function block_copy_sanitize($input)
        {
            $sanitary_values = array();
            if (isset($input['your_site_is_protected_0'])) {
                $sanitary_values['your_site_is_protected_0'] = sanitize_text_field($input['your_site_is_protected_0']);
            }

            return $sanitary_values;
        }

        public function block_copy_section_info()
        {
        }

        public function your_site_is_protected_0_callback()
        {
            printf(
                '<input class="regular-text" type="text" name="block_copy_option_name[your_site_is_protected_0]" id="your_site_is_protected_0" value="%s">',
                isset($this->block_copy_options['your_site_is_protected_0']) ? esc_attr($this->block_copy_options['your_site_is_protected_0']) : ''
            );
        }
    }
    if (is_admin()) {
        $block_copy = new BlockCopy();
    }

/*
 * Retrieve this value with:
 * $block_copy_options = get_option( 'block_copy_option_name' ); // Array of All Options
 * $your_site_is_protected_0 = $block_copy_options['your_site_is_protected_0']; // Your site is protected!
 */
